#!/usr/bin/perl

package OrpheusParser;

#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
# author mt
# Parser for orpheus output files (version 2). 
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
use YACOP::gene_pred::DataHandle;

my $TYPE = "OrpheusParser";
my $NAME = "Orpheus";

my $DIFF_END = 2;    #difference between notation of orpheus and yacop 
my $DIFF_START = 1;   #(distinction of end positions in F/R-Strand)

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Whole data from given file is read and stored as Element-objects to a new
# created DataHandle. 
# Start and end positions are changed to yacop notation by $DIFF_END (only 
# necessary in F-strand)
# res $DIFF_START. 
#@param filename of orpheus-output
#-----------------------
sub parse{
    my ($self, $file) = @_;
    my $data_handle = DataHandle->new($TYPE);
    my @array;
    open (orpheus_input, $file )  
	|| die "cannot open orpheus file ".$file."\n";
    while (<orpheus_input>){
	if ( /\>/){
	    @array = split;
	    $array[0] =~ /\d+/;
	    my $com = $self->complement($array[1], $array[2]);
	    if ($com =~/F/i){
		$diff =$DIFF_END;
	    }
	    else{
		$diff =0
	    }
	    $data_handle->add_element($&, ($array[1]+$DIFF_START), 
				      ($array[2]+$diff), $com, 
				      " ", $array[3]);
	}
    }
    close(orpheus_input);
    return $data_handle; 
}  

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# Calulates the complement of given start - end position. 
# (for deprecated routin with orf nr see CriticaParser::complement_no())
# @param $start
# @param $end
# @return complement (format: F2)
#---------------------------
sub complement{
    my ($self, $start, $end) = @_;
    return 'F' if ($start<$end);
    return 'R';
}

sub name{
  return $NAME;
}


sub type{
    return $TYPE;
}
return 1;
