#!/usr/bin/perl

package PropertyHandle;
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
# author mt
# Object to read out given inifile.
# format: tag=value
# comments are quoted with '#'
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# @param ini file
#-------------
sub new{
    my $self = { };
    bless $self, shift;
    $self->{INI_FILE} = shift;
    $self->read_properties($self->{INI_FILE});
    return $self;
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# @return hash holding properties
#-------------
sub get_properties{
    my $self = shift;
#    return %{$self->{PROPERTY}};
    return $self->{PROPERTY};
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# @param property name
# @return property value or NULL
#-------------
sub get_property{
    my $self = shift;
    my $tmp = shift;
    return $self->{PROPERTY}{$tmp} if ($self->{PROPERTY});
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# routine to read ini file
#-------------
sub read_properties{
    my $self = shift;
    my @tmp;
    open (input, $self->{INI_FILE}) 
	|| die "can not open ini file ".$self->{INI_FILE}."\n";
    while (<input>){
	chomp($_);
	$_ =~ s/\#.+|\#|\s//g;   #remove comments
	@tmp = split "=";
	if ($tmp[1]){
	    $self->{PROPERTY}{$tmp[0]} = $tmp[1];
	}
	else{
	    undef $self->{PROPERTY}{$tmp[0]};
	}
    }
    close(input);
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# routine writes current properties to given file. 
# @param filename 
#--------------
sub write_properties{
    my $self = shift; 
    my $tmp = shift;
    if ($tmp){
     open (output, ">>".$tmp)|| 
          die "cannot open file ".$tmp."\n";
      print output "Properties-File of YACOP".
                   "\n----------------------------\n";
      @key_set = keys %{$self->{PROPERTY}};
        foreach(@key_set){
	    print output $_."=".$self->{PROPERTY}{$_}."\n" if($_ ne "");
        }
     close output;
   }
}
return 1;
