#!/usr/bin/perl

package ZCurveNudge;
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
# author mt
# ZCurveNudge - Starter class for Linux version of ZCurve1.02
# NOTE: Processes are not startet as batch processes. It's not
#       necessary caus runtime takes only minutes for each subprocess.
#=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*

@ISA=(Nudge);
$|=1;

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# @param FASTA
# @param OUTPUT_DIR
# @param PREFIX
#---------------------
sub new{
    my $self = shift;
    $self = $self->SUPER::new(shift, shift, shift);
    $self->{RESULT_OUTPUT} = $self->{OUTPUT_DIR}."/gl_".$self->{PREFIX}
                             .".rbsout";
    $self->{RESULT_OUTPUT} = $self->{OUTPUT_DIR}."/zc_".$self->{PREFIX}.".out";
    $self->{ZC_MSG} = $self->{OUTPUT_DIR}."/zc_".$self->{PREFIX}
                      .".msg";
    return $self
}

#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# starts zcurve process
#---------------------
sub start_zcurve{
    my $self = shift;
    system "cp ".$self->{PARAMETER}{zcurve_home}."/random.dat ".$ENV{PWD};
    system $self->{PARAMETER}{zcurve_home}."/".$self->{PARAMETER}{zcurve_call}.
	" ".$self->{FASTA}." ".$self->{RESULT_OUTPUT}.
	$self->{PARAMETER}{zcurve_minlength}.$self->{PARAMETER}{zcurve_myco}.
	" > ".$self->{ZC_MSG}."\n";
    system "rm ".$ENV{PWD}."/random.dat ";
}


#++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
# evaluation of given properties.
# @see zcurve documentation and ini file
# @param properties
#----------------------
sub set_parameter{
    my $self = shift;
    $self->{PARAMETER} = shift;
    if (!$self->{PARAMETER}{zcurve_home}){return 0}
    if ( $self->{PARAMETER}{zcurve_minlength}){       #minlength
	$self->{PARAMETER}{zcurve_minlength} = " -g ".
	    $self->{PARAMETER}{zcurve_minlength}}
    if ( $self->{PARAMETER}{zcurve_myco} eq "true"){        #mycoplasma
	$self->{PARAMETER}{zcurve_myco} = " -m "}
    else{undef $self->{PARAMETER}{zcurve_myco}}	
    return 1
}
return 1;

